import * as i0 from '@angular/core';
import { Inject, Component, EventEmitter, forwardRef, HostBinding, Input, ViewChild, Injectable, signal, NgModule } from '@angular/core';
import * as i2$1 from '@angular/common';
import { NgForOf, CommonModule } from '@angular/common';
import * as i1 from '@angular/material/dialog';
import { MAT_DIALOG_DATA, MatDialogModule } from '@angular/material/dialog';
import * as i2 from '@angular/material/button';
import { MatButtonModule } from '@angular/material/button';
import * as i1$1 from '@meshmakers/shared-services';
import { IsoDateTime } from '@meshmakers/shared-services';
import * as i4 from '@angular/material/toolbar';
import { MatToolbarModule } from '@angular/material/toolbar';
import * as i6 from '@angular/material/icon';
import { MatIconModule, MatIcon } from '@angular/material/icon';
import * as i2$2 from '@angular/material/snack-bar';
import { MatSnackBarModule } from '@angular/material/snack-bar';
import { MatFormFieldControl, MatFormFieldModule } from '@angular/material/form-field';
import * as i6$1 from '@angular/forms';
import { FormControl, NgControl, NG_VALUE_ACCESSOR, NG_VALIDATORS, ReactiveFormsModule, Validators } from '@angular/forms';
import { coerceBooleanProperty } from '@angular/cdk/coercion';
import { debounceTime, filter, tap, map, switchMap } from 'rxjs/operators';
import { Subject, of, BehaviorSubject, firstValueFrom } from 'rxjs';
import * as i1$2 from '@angular/cdk/a11y';
import * as i3 from '@angular/material/autocomplete';
import { MatAutocompleteModule } from '@angular/material/autocomplete';
import * as i4$1 from '@angular/material/input';
import { MatInputModule } from '@angular/material/input';
import * as i5 from '@angular/material/progress-spinner';
import { MatProgressSpinnerModule } from '@angular/material/progress-spinner';
import { ENTER, COMMA } from '@angular/cdk/keycodes';
import * as i6$2 from '@angular/material/chips';
import { MatChipsModule } from '@angular/material/chips';
import * as i1$3 from '@angular/router';
import { NavigationEnd, PRIMARY_OUTLET, RouterLink } from '@angular/router';
import * as i4$2 from '@angular/material/list';
import { MatListModule } from '@angular/material/list';
import * as i4$3 from '@angular/material/progress-bar';
import { MatProgressBar } from '@angular/material/progress-bar';
import { MatTable, MatColumnDef, MatHeaderCell, MatCell, MatHeaderRow, MatRow, MatHeaderRowDef, MatRowDef, MatHeaderCellDef, MatCellDef } from '@angular/material/table';
import { MatSort, MatSortHeader } from '@angular/material/sort';

class MmMessageDetailsComponent {
    dialogRef;
    data;
    errorMessage;
    constructor(dialogRef, data) {
        this.dialogRef = dialogRef;
        this.data = data;
        this.errorMessage = data.errorMessage;
    }
    ngOnInit() { }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.14", ngImport: i0, type: MmMessageDetailsComponent, deps: [{ token: i1.MatDialogRef }, { token: MAT_DIALOG_DATA }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.2.14", type: MmMessageDetailsComponent, isStandalone: false, selector: "mm-message-details", ngImport: i0, template: "<mat-dialog-content>\n\n  <h2>{{errorMessage.title}}</h2>\n  <p>{{errorMessage.message}}</p>\n\n\n</mat-dialog-content>\n<mat-dialog-actions align=\"end\">\n  <button class=\"primary-button\" mat-dialog-close mat-flat-button>OK</button>\n</mat-dialog-actions>\n", styles: [""], dependencies: [{ kind: "component", type: i2.MatButton, selector: "    button[mat-button], button[mat-raised-button], button[mat-flat-button],    button[mat-stroked-button]  ", exportAs: ["matButton"] }, { kind: "directive", type: i1.MatDialogClose, selector: "[mat-dialog-close], [matDialogClose]", inputs: ["aria-label", "type", "mat-dialog-close", "matDialogClose"], exportAs: ["matDialogClose"] }, { kind: "directive", type: i1.MatDialogActions, selector: "[mat-dialog-actions], mat-dialog-actions, [matDialogActions]", inputs: ["align"] }, { kind: "directive", type: i1.MatDialogContent, selector: "[mat-dialog-content], mat-dialog-content, [matDialogContent]" }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.14", ngImport: i0, type: MmMessageDetailsComponent, decorators: [{
            type: Component,
            args: [{ selector: 'mm-message-details', standalone: false, template: "<mat-dialog-content>\n\n  <h2>{{errorMessage.title}}</h2>\n  <p>{{errorMessage.message}}</p>\n\n\n</mat-dialog-content>\n<mat-dialog-actions align=\"end\">\n  <button class=\"primary-button\" mat-dialog-close mat-flat-button>OK</button>\n</mat-dialog-actions>\n" }]
        }], ctorParameters: () => [{ type: i1.MatDialogRef }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [MAT_DIALOG_DATA]
                }] }] });

class MmNotificationBarComponent {
    messageService;
    dialog;
    errorMessage;
    constructor(messageService, dialog) {
        this.messageService = messageService;
        this.dialog = dialog;
        this.errorMessage = null;
    }
    ngOnInit() {
        this.messageService.getLatestErrorMessage().subscribe((value) => {
            this.errorMessage = value;
        });
    }
    onHide() {
        this.errorMessage = null;
    }
    onShowDetails() {
        this.dialog.open(MmMessageDetailsComponent, {
            data: {
                errorMessage: this.errorMessage
            }
        });
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.14", ngImport: i0, type: MmNotificationBarComponent, deps: [{ token: i1$1.MessageService }, { token: i1.MatDialog }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.2.14", type: MmNotificationBarComponent, isStandalone: false, selector: "mm-notification-bar", ngImport: i0, template: "<mat-toolbar [ngClass]=\"{ 'notification-bar-hidden': !errorMessage }\" class=\"mm-notification-bar-background\">\n  <a (click)=\"onShowDetails()\"><span class=\"mat-small\"><u>{{ errorMessage?.title }}</u></span></a>\n\n  <!-- This fills the remaining space of the current row -->\n  <span class=\"notification-fill-remaining-space\"></span>\n\n  <button (click)=\"onHide()\" class=\"mm-notification-bar-button\" mat-fab><mat-icon class=\"material-symbols-outlined\">close</mat-icon></button>\n</mat-toolbar>\n", styles: [".notification-fill-remaining-space{flex:1 1 auto}.notification-bar-hidden{display:none}\n"], dependencies: [{ kind: "directive", type: i2$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "component", type: i4.MatToolbar, selector: "mat-toolbar", inputs: ["color"], exportAs: ["matToolbar"] }, { kind: "component", type: i2.MatFabButton, selector: "button[mat-fab]", inputs: ["extended"], exportAs: ["matButton"] }, { kind: "component", type: i6.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.14", ngImport: i0, type: MmNotificationBarComponent, decorators: [{
            type: Component,
            args: [{ selector: 'mm-notification-bar', standalone: false, template: "<mat-toolbar [ngClass]=\"{ 'notification-bar-hidden': !errorMessage }\" class=\"mm-notification-bar-background\">\n  <a (click)=\"onShowDetails()\"><span class=\"mat-small\"><u>{{ errorMessage?.title }}</u></span></a>\n\n  <!-- This fills the remaining space of the current row -->\n  <span class=\"notification-fill-remaining-space\"></span>\n\n  <button (click)=\"onHide()\" class=\"mm-notification-bar-button\" mat-fab><mat-icon class=\"material-symbols-outlined\">close</mat-icon></button>\n</mat-toolbar>\n", styles: [".notification-fill-remaining-space{flex:1 1 auto}.notification-bar-hidden{display:none}\n"] }]
        }], ctorParameters: () => [{ type: i1$1.MessageService }, { type: i1.MatDialog }] });

class MmAutocompleteInputComponent {
    elRef;
    injector;
    fm;
    static nextId = 0;
    searchFormControl;
    isLoading;
    filteredStrings = [];
    ngControl;
    errorState;
    focused;
    stateChanges = new Subject();
    id = `ia-autocomplete-${MmAutocompleteInputComponent.nextId++}`;
    valueChange = new EventEmitter();
    _selectedString;
    inputField;
    describedBy = "";
    activatedValue;
    constructor(elRef, injector, fm) {
        this.elRef = elRef;
        this.injector = injector;
        this.fm = fm;
        this.ngControl = null;
        this.errorState = false;
        this._selectedString = null;
        this.inputField = null;
        this._dataSource = null;
        this._placeholder = "";
        this._prefix = "";
        this.searchFormControl = new FormControl();
        this.isLoading = false;
        this._disabled = false;
        this.focused = false;
        fm.monitor(elRef.nativeElement, true).subscribe((origin) => {
            this.focused = !!origin;
            this.stateChanges.next();
        });
    }
    _dataSource;
    get dataSource() {
        return this._dataSource;
    }
    set dataSource(value) {
        this._dataSource = value;
    }
    _disabled = false;
    get disabled() {
        return this._disabled;
    }
    set disabled(dis) {
        this._disabled = coerceBooleanProperty(dis);
        if (this._disabled) {
            this.searchFormControl.disable();
        }
        else {
            this.searchFormControl.enable();
        }
        this.stateChanges.next();
    }
    _placeholder;
    get placeholder() {
        return this._placeholder;
    }
    set placeholder(plh) {
        this._placeholder = plh;
        this.stateChanges.next();
    }
    _required = false;
    get required() {
        return this._required;
    }
    set required(req) {
        this._required = coerceBooleanProperty(req);
        if (this.inputField != null) {
            this.inputField.required = this._required;
        }
        this.stateChanges.next();
    }
    _prefix;
    get prefix() {
        return this._prefix;
    }
    set prefix(value) {
        if (value !== this._prefix) {
            this._prefix = value;
        }
    }
    get value() {
        return this._selectedString;
    }
    set value(value) {
        if (value !== this._selectedString) {
            this._selectedString = value;
            this.searchFormControl.setValue(value);
            this.valueChange.emit(value);
            this._propagateChange(this._selectedString);
            this.stateChanges.next();
        }
    }
    get empty() {
        const n = this.searchFormControl.value;
        return !n;
    }
    get shouldLabelFloat() {
        return this.focused || !this.empty;
    }
    ngOnInit() {
        this.ngControl = this.injector.get(NgControl, null);
        if (this.ngControl != null) {
            this.ngControl.valueAccessor = this;
        }
        // If prefix defined, usually this is used for a code scanner.
        // The goal is to select the entity in direct way.
        if (this._prefix) {
            this.searchFormControl.valueChanges
                .pipe(debounceTime(300), filter((value) => typeof value === "string"), filter((value) => value.startsWith(this._prefix)), tap(() => (this.value = null)), tap(() => (this.isLoading = true)), map((value) => this._dataSource?.onPreprocessSearchString(value) ?? ""), switchMap((value) => this._dataSource?.onFilter(value) ?? of(null)))
                .subscribe((resultSet) => {
                if (resultSet?.list != null) {
                    if (resultSet.list.length === 1) {
                        this.value = resultSet.list[0];
                    }
                    else {
                        this.filteredStrings = resultSet.list;
                        this.searchFormControl.patchValue(resultSet.searchTerm, {
                            emitEvent: false
                        });
                    }
                }
                this.isLoading = false;
            });
        }
        // This is the search functionality when search by human.
        this.searchFormControl.valueChanges
            .pipe(debounceTime(300), tap((_) => {
            this.filteredStrings = [];
        }), filter((value) => value != null && value.toString().length >= 1), tap(() => (this.isLoading = true)), map((value) => this._dataSource?.onPreprocessSearchString(value)), tap((value) => (this.value = value)), switchMap((value) => {
            if (value !== null) {
                return this._dataSource?.onFilter(String(value)) ?? of(null);
            }
            return of(null);
        }))
            .subscribe((resultSet) => {
            if (resultSet?.list != null) {
                this.filteredStrings = resultSet.list;
                this.searchFormControl.patchValue(resultSet.searchTerm, {
                    emitEvent: false
                });
            }
            this.isLoading = false;
        });
    }
    ngOnDestroy() {
        this.stateChanges.complete();
        this.fm.stopMonitoring(this.elRef.nativeElement);
    }
    ngDoCheck() {
        if (this.ngControl != null) {
            this.errorState = (this.ngControl.invalid && this.ngControl.touched) ?? false;
            this.stateChanges.next();
        }
    }
    clear() {
        this.filteredStrings = [];
        this.searchFormControl.reset(null);
    }
    focus() {
        this.elRef.nativeElement.querySelector("input")?.focus();
    }
    onOptionSelected(event) {
        this.value = event.option.value;
        this.filteredStrings = [];
    }
    onOptionActivated(event) {
        this.activatedValue = event.option?.value;
    }
    onAutoCompleteClosed() {
        if (this.activatedValue) {
            this.value = this.activatedValue;
            this.activatedValue = null;
        }
    }
    reset() {
        this.value = null;
    }
    onFocusOut() {
        if (this.filteredStrings.length === 1) {
            this.activatedValue = this.filteredStrings[0];
            this.value = this.filteredStrings[0];
        }
    }
    onTouched() {
        this._onTouched();
        this.stateChanges.next();
    }
    registerOnChange(fn) {
        this._propagateChange = fn;
    }
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    writeValue(obj) {
        this.clear();
        this.value = obj;
    }
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
    onContainerClick(event) {
        if (event.target.tagName.toLowerCase() !== "input") {
            this.focus();
        }
    }
    setDescribedByIds(ids) {
        this.describedBy = ids.join(" ");
    }
    validate(control) {
        const selection = control.value;
        if (typeof selection === "string" && selection.length < 1) {
            return { incorrect: true };
        }
        return null;
    }
    _propagateChange = (_) => {
    };
    _onTouched = () => {
    };
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.14", ngImport: i0, type: MmAutocompleteInputComponent, deps: [{ token: i0.ElementRef }, { token: i0.Injector }, { token: i1$2.FocusMonitor }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.2.14", type: MmAutocompleteInputComponent, isStandalone: false, selector: "mm-autocomplete", inputs: { dataSource: "dataSource", disabled: "disabled", placeholder: "placeholder", required: "required", prefix: "prefix" }, host: { properties: { "id": "this.id", "attr.aria-describedby": "this.describedBy", "class.floating": "this.shouldLabelFloat" } }, providers: [
            {
                provide: NG_VALUE_ACCESSOR,
                useExisting: forwardRef(() => MmAutocompleteInputComponent),
                multi: true
            },
            {
                provide: MatFormFieldControl,
                useExisting: MmAutocompleteInputComponent
            },
            {
                provide: NG_VALIDATORS,
                useExisting: forwardRef(() => MmAutocompleteInputComponent),
                multi: true
            }
        ], viewQueries: [{ propertyName: "inputField", first: true, predicate: ["input"], descendants: true }], ngImport: i0, template: "<input #input (blur)=\"onTouched()\" (focusout)=\"onFocusOut()\" [formControl]=\"searchFormControl\" [matAutocomplete]=\"auto\"\n       [placeholder]=\"placeholder\" matInput>\n<mat-autocomplete #auto=\"matAutocomplete\"\n                  (closed)=\"onAutoCompleteClosed()\" (optionActivated)=\"onOptionActivated($event)\"\n                  (optionSelected)=\"onOptionSelected($event)\">\n  <mat-option *ngIf=\"isLoading\" class=\"is-loading\">\n    <mat-spinner diameter=\"50\"></mat-spinner>\n  </mat-option>\n  <ng-container *ngIf=\"!isLoading\">\n    <mat-option *ngFor=\"let str of filteredStrings\" [value]=\"str\">\n      {{str}}\n    </mat-option>\n  </ng-container>\n</mat-autocomplete>\n", styles: ["span{opacity:0;transition:opacity .2s}:host.floating span{opacity:1}\n"], dependencies: [{ kind: "directive", type: i2$1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: i3.MatAutocomplete, selector: "mat-autocomplete", inputs: ["aria-label", "aria-labelledby", "displayWith", "autoActiveFirstOption", "autoSelectActiveOption", "requireSelection", "panelWidth", "disableRipple", "class", "hideSingleSelectionIndicator"], outputs: ["optionSelected", "opened", "closed", "optionActivated"], exportAs: ["matAutocomplete"] }, { kind: "component", type: i3.MatOption, selector: "mat-option", inputs: ["value", "id", "disabled"], outputs: ["onSelectionChange"], exportAs: ["matOption"] }, { kind: "directive", type: i3.MatAutocompleteTrigger, selector: "input[matAutocomplete], textarea[matAutocomplete]", inputs: ["matAutocomplete", "matAutocompletePosition", "matAutocompleteConnectedTo", "autocomplete", "matAutocompleteDisabled"], exportAs: ["matAutocompleteTrigger"] }, { kind: "directive", type: i4$1.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly", "disabledInteractive"], exportAs: ["matInput"] }, { kind: "component", type: i5.MatProgressSpinner, selector: "mat-progress-spinner, mat-spinner", inputs: ["color", "mode", "value", "diameter", "strokeWidth"], exportAs: ["matProgressSpinner"] }, { kind: "directive", type: i6$1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i6$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i6$1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.14", ngImport: i0, type: MmAutocompleteInputComponent, decorators: [{
            type: Component,
            args: [{ selector: "mm-autocomplete", standalone: false, host: {
                        "[id]": "id",
                        "[attr.aria-describedby]": "describedBy"
                    }, providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef(() => MmAutocompleteInputComponent),
                            multi: true
                        },
                        {
                            provide: MatFormFieldControl,
                            useExisting: MmAutocompleteInputComponent
                        },
                        {
                            provide: NG_VALIDATORS,
                            useExisting: forwardRef(() => MmAutocompleteInputComponent),
                            multi: true
                        }
                    ], template: "<input #input (blur)=\"onTouched()\" (focusout)=\"onFocusOut()\" [formControl]=\"searchFormControl\" [matAutocomplete]=\"auto\"\n       [placeholder]=\"placeholder\" matInput>\n<mat-autocomplete #auto=\"matAutocomplete\"\n                  (closed)=\"onAutoCompleteClosed()\" (optionActivated)=\"onOptionActivated($event)\"\n                  (optionSelected)=\"onOptionSelected($event)\">\n  <mat-option *ngIf=\"isLoading\" class=\"is-loading\">\n    <mat-spinner diameter=\"50\"></mat-spinner>\n  </mat-option>\n  <ng-container *ngIf=\"!isLoading\">\n    <mat-option *ngFor=\"let str of filteredStrings\" [value]=\"str\">\n      {{str}}\n    </mat-option>\n  </ng-container>\n</mat-autocomplete>\n", styles: ["span{opacity:0;transition:opacity .2s}:host.floating span{opacity:1}\n"] }]
        }], ctorParameters: () => [{ type: i0.ElementRef }, { type: i0.Injector }, { type: i1$2.FocusMonitor }], propDecorators: { id: [{
                type: HostBinding
            }], inputField: [{
                type: ViewChild,
                args: ["input"]
            }], describedBy: [{
                type: HostBinding,
                args: ["attr.aria-describedby"]
            }], dataSource: [{
                type: Input
            }], disabled: [{
                type: Input
            }], placeholder: [{
                type: Input
            }], required: [{
                type: Input
            }], prefix: [{
                type: Input
            }], shouldLabelFloat: [{
                type: HostBinding,
                args: ["class.floating"]
            }] } });

class MmEntitySelectInputComponent {
    elRef;
    injector;
    fm;
    static nextId = 0;
    searchFormControl;
    isLoading;
    filteredEntities = [];
    ngControl;
    errorState;
    focused;
    stateChanges = new Subject();
    id = `ia-entity-select-${MmEntitySelectInputComponent.nextId++}`;
    valueChange = new EventEmitter();
    _selectedEntity;
    inputField;
    describedBy = "";
    activatedValue;
    constructor(elRef, injector, fm) {
        this.elRef = elRef;
        this.injector = injector;
        this.fm = fm;
        this.ngControl = null;
        this.errorState = false;
        this.inputField = null;
        this._dataSource = null;
        this._placeholder = "";
        this._prefix = "";
        this.searchFormControl = new FormControl();
        this.isLoading = false;
        this._disabled = false;
        this.focused = false;
        fm.monitor(elRef.nativeElement, true).subscribe((origin) => {
            this.focused = !!origin;
            this.stateChanges.next();
        });
    }
    _dataSource;
    get dataSource() {
        return this._dataSource;
    }
    set dataSource(value) {
        this._dataSource = value;
    }
    _disabled = false;
    get disabled() {
        return this._disabled;
    }
    set disabled(dis) {
        this._disabled = coerceBooleanProperty(dis);
        if (this._disabled) {
            this.searchFormControl.disable();
        }
        else {
            this.searchFormControl.enable();
        }
        this.stateChanges.next();
    }
    _placeholder;
    get placeholder() {
        return this._placeholder;
    }
    set placeholder(plh) {
        this._placeholder = plh;
        this.stateChanges.next();
    }
    _required = false;
    get required() {
        return this._required;
    }
    set required(req) {
        this._required = coerceBooleanProperty(req);
        if (this.inputField != null) {
            this.inputField.required = this._required;
        }
        this.stateChanges.next();
    }
    _prefix;
    get prefix() {
        return this._prefix;
    }
    set prefix(value) {
        if (value !== this._prefix) {
            this._prefix = value;
        }
    }
    get value() {
        return this._selectedEntity;
    }
    set value(value) {
        if (value !== this._selectedEntity) {
            this.searchFormControl.setValue(value);
            this.setValue(value);
        }
    }
    get empty() {
        const n = this.searchFormControl.value;
        return !n;
    }
    get shouldLabelFloat() {
        return this.focused || !this.empty;
    }
    ngOnInit() {
        this.ngControl = this.injector.get(NgControl, null);
        if (this.ngControl != null) {
            this.ngControl.valueAccessor = this;
        }
        // If prefix defined, usually this is used for a code scanner.
        // The goal is to select the entity in direct way.
        if (this._prefix) {
            this.searchFormControl.valueChanges
                .pipe(debounceTime(300), filter((value) => typeof value === "string"), filter((value) => value.startsWith(this._prefix)), tap(() => (this.value = null)), tap(() => (this.isLoading = true)))
                .subscribe(async (value) => {
                if (!this._dataSource) {
                    this.isLoading = false;
                    return;
                }
                const resultSet = await this._dataSource?.onFilter(value.replace(this._prefix, "").trim());
                if (resultSet.list) {
                    if (resultSet.list.length === 1) {
                        this.value = resultSet.list[0];
                    }
                    else {
                        this.filteredEntities = resultSet.list;
                    }
                }
                this.isLoading = false;
            });
        }
        // This is the search functionality when search by human.
        this.searchFormControl.valueChanges
            .pipe(debounceTime(300), tap(() => (this.filteredEntities = [])), filter((value) => typeof value === "string"), tap(() => {
            this.setValue(null);
        }), filter((value) => value.toString().length >= 3), tap(() => (this.isLoading = true)))
            .subscribe(async (value) => {
            if (!this._dataSource) {
                this.isLoading = false;
                return;
            }
            const resultSet = await this._dataSource.onFilter(value);
            if (resultSet?.list) {
                this.filteredEntities = resultSet.list;
            }
            this.isLoading = false;
        });
    }
    ngOnDestroy() {
        this.stateChanges.complete();
        this.fm.stopMonitoring(this.elRef.nativeElement);
    }
    ngDoCheck() {
        if (this.ngControl != null) {
            this.errorState = (this.ngControl.invalid && this.ngControl.touched) ?? false;
            this.stateChanges.next();
        }
    }
    clear() {
        this.filteredEntities = [];
        this.searchFormControl.reset(null);
    }
    focus() {
        this.elRef.nativeElement.querySelector("input")?.focus();
    }
    onEntitySelected(event) {
        this.value = event.option.value;
        this.filteredEntities = [];
    }
    onEntityActivated(event) {
        this.activatedValue = event.option?.value;
    }
    onEntityClosed() {
        if (this.activatedValue) {
            this.value = this.activatedValue;
            this.activatedValue = null;
        }
    }
    reset() {
        this.value = null;
    }
    onFocusOut() {
        if (this.filteredEntities.length === 1) {
            this.activatedValue = this.filteredEntities[0];
            this.value = this.filteredEntities[0];
        }
    }
    onTouched() {
        this._onTouched();
        this.stateChanges.next();
    }
    registerOnChange(fn) {
        this._propagateChange = fn;
    }
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    writeValue(obj) {
        this.clear();
        this.value = obj;
    }
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
    onContainerClick(event) {
        if (event.target.tagName.toLowerCase() !== "input") {
            this.focus();
        }
    }
    setDescribedByIds(ids) {
        this.describedBy = ids.join(" ");
    }
    validate(control) {
        const selection = control.value;
        if (typeof selection === "string") {
            return { incorrect: true };
        }
        return null;
    }
    _propagateChange = (_) => {
    };
    _onTouched = () => {
    };
    setValue(value) {
        if (value !== this._selectedEntity) {
            this._selectedEntity = value;
            this.valueChange.emit(value);
            this._propagateChange(this._selectedEntity);
            this.stateChanges.next();
        }
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.14", ngImport: i0, type: MmEntitySelectInputComponent, deps: [{ token: i0.ElementRef }, { token: i0.Injector }, { token: i1$2.FocusMonitor }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.2.14", type: MmEntitySelectInputComponent, isStandalone: false, selector: "mm-entity-select", inputs: { dataSource: "dataSource", disabled: "disabled", placeholder: "placeholder", required: "required", prefix: "prefix" }, host: { properties: { "id": "this.id", "attr.aria-describedby": "this.describedBy", "class.floating": "this.shouldLabelFloat" } }, providers: [
            {
                provide: NG_VALUE_ACCESSOR,
                useExisting: forwardRef(() => MmEntitySelectInputComponent),
                multi: true
            },
            {
                provide: MatFormFieldControl,
                useExisting: MmEntitySelectInputComponent
            },
            {
                provide: NG_VALIDATORS,
                useExisting: forwardRef(() => MmEntitySelectInputComponent),
                multi: true
            }
        ], viewQueries: [{ propertyName: "inputField", first: true, predicate: ["input"], descendants: true }], ngImport: i0, template: "<input #input (blur)=\"onTouched()\" (focusout)=\"onFocusOut()\" [formControl]=\"searchFormControl\" [matAutocomplete]=\"auto\"\n       [placeholder]=\"placeholder\" matInput>\n<mat-autocomplete #auto=\"matAutocomplete\" (closed)=\"onEntityClosed()\"\n                  (optionActivated)=\"onEntityActivated($event)\" (optionSelected)=\"onEntitySelected($event)\"\n                  [displayWith]=\"dataSource?.onDisplayEntity ?? null\">\n  <mat-option *ngIf=\"isLoading\" class=\"is-loading\">\n    <mat-spinner diameter=\"50\"></mat-spinner>\n  </mat-option>\n  <ng-container *ngIf=\"!isLoading\">\n    <mat-option *ngFor=\"let entity of filteredEntities\" [value]=\"entity\">\n      {{dataSource?.onDisplayEntity(entity) ?? null}}\n    </mat-option>\n  </ng-container>\n</mat-autocomplete>\n", styles: ["span{opacity:0;transition:opacity .2s}:host.floating span{opacity:1}\n"], dependencies: [{ kind: "directive", type: i2$1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: i3.MatAutocomplete, selector: "mat-autocomplete", inputs: ["aria-label", "aria-labelledby", "displayWith", "autoActiveFirstOption", "autoSelectActiveOption", "requireSelection", "panelWidth", "disableRipple", "class", "hideSingleSelectionIndicator"], outputs: ["optionSelected", "opened", "closed", "optionActivated"], exportAs: ["matAutocomplete"] }, { kind: "component", type: i3.MatOption, selector: "mat-option", inputs: ["value", "id", "disabled"], outputs: ["onSelectionChange"], exportAs: ["matOption"] }, { kind: "directive", type: i3.MatAutocompleteTrigger, selector: "input[matAutocomplete], textarea[matAutocomplete]", inputs: ["matAutocomplete", "matAutocompletePosition", "matAutocompleteConnectedTo", "autocomplete", "matAutocompleteDisabled"], exportAs: ["matAutocompleteTrigger"] }, { kind: "directive", type: i4$1.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly", "disabledInteractive"], exportAs: ["matInput"] }, { kind: "component", type: i5.MatProgressSpinner, selector: "mat-progress-spinner, mat-spinner", inputs: ["color", "mode", "value", "diameter", "strokeWidth"], exportAs: ["matProgressSpinner"] }, { kind: "directive", type: i6$1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i6$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i6$1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.14", ngImport: i0, type: MmEntitySelectInputComponent, decorators: [{
            type: Component,
            args: [{ selector: "mm-entity-select", standalone: false, host: {
                        "[id]": "id",
                        "[attr.aria-describedby]": "describedBy"
                    }, providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef(() => MmEntitySelectInputComponent),
                            multi: true
                        },
                        {
                            provide: MatFormFieldControl,
                            useExisting: MmEntitySelectInputComponent
                        },
                        {
                            provide: NG_VALIDATORS,
                            useExisting: forwardRef(() => MmEntitySelectInputComponent),
                            multi: true
                        }
                    ], template: "<input #input (blur)=\"onTouched()\" (focusout)=\"onFocusOut()\" [formControl]=\"searchFormControl\" [matAutocomplete]=\"auto\"\n       [placeholder]=\"placeholder\" matInput>\n<mat-autocomplete #auto=\"matAutocomplete\" (closed)=\"onEntityClosed()\"\n                  (optionActivated)=\"onEntityActivated($event)\" (optionSelected)=\"onEntitySelected($event)\"\n                  [displayWith]=\"dataSource?.onDisplayEntity ?? null\">\n  <mat-option *ngIf=\"isLoading\" class=\"is-loading\">\n    <mat-spinner diameter=\"50\"></mat-spinner>\n  </mat-option>\n  <ng-container *ngIf=\"!isLoading\">\n    <mat-option *ngFor=\"let entity of filteredEntities\" [value]=\"entity\">\n      {{dataSource?.onDisplayEntity(entity) ?? null}}\n    </mat-option>\n  </ng-container>\n</mat-autocomplete>\n", styles: ["span{opacity:0;transition:opacity .2s}:host.floating span{opacity:1}\n"] }]
        }], ctorParameters: () => [{ type: i0.ElementRef }, { type: i0.Injector }, { type: i1$2.FocusMonitor }], propDecorators: { id: [{
                type: HostBinding
            }], inputField: [{
                type: ViewChild,
                args: ["input"]
            }], describedBy: [{
                type: HostBinding,
                args: ["attr.aria-describedby"]
            }], dataSource: [{
                type: Input
            }], disabled: [{
                type: Input
            }], placeholder: [{
                type: Input
            }], required: [{
                type: Input
            }], prefix: [{
                type: Input
            }], shouldLabelFloat: [{
                type: HostBinding,
                args: ["class.floating"]
            }] } });

class MmMultipleEntitySelectInputComponent {
    elRef;
    injector;
    fm;
    static nextId = 0;
    valuesFormControl;
    searchFormControl;
    isLoading;
    filteredEntities = [];
    ngControl;
    errorState;
    focused;
    stateChanges = new Subject();
    id = `ia-multiple-entity-select-${MmMultipleEntitySelectInputComponent.nextId++}`;
    valuesChange = new EventEmitter();
    _selectedEntities;
    inputField;
    describedBy = '';
    activatedValue;
    separatorKeysCodes = [ENTER, COMMA];
    constructor(elRef, injector, fm) {
        this.elRef = elRef;
        this.injector = injector;
        this.fm = fm;
        this.ngControl = null;
        this.errorState = false;
        this.inputField = null;
        this._dataSource = null;
        this._placeholder = '';
        this._prefix = '';
        this._selectedEntities = null;
        this.valuesFormControl = new FormControl();
        this.searchFormControl = new FormControl();
        this.isLoading = false;
        this._disabled = false;
        this.focused = false;
        fm.monitor(elRef.nativeElement, true).subscribe((origin) => {
            this.focused = !!origin;
            this.stateChanges.next();
        });
    }
    _dataSource;
    get dataSource() {
        return this._dataSource;
    }
    set dataSource(value) {
        this._dataSource = value;
    }
    _disabled = false;
    get disabled() {
        return this._disabled;
    }
    set disabled(dis) {
        this._disabled = coerceBooleanProperty(dis);
        if (this._disabled) {
            this.searchFormControl.disable();
        }
        else {
            this.searchFormControl.enable();
        }
        this.stateChanges.next();
    }
    _placeholder;
    get placeholder() {
        return this._placeholder;
    }
    set placeholder(plh) {
        this._placeholder = plh;
        this.stateChanges.next();
    }
    _required = false;
    get required() {
        return this._required;
    }
    set required(req) {
        this._required = coerceBooleanProperty(req);
        if (this.inputField != null) {
            this.inputField.required = this._required;
        }
        this.stateChanges.next();
    }
    _prefix;
    get prefix() {
        return this._prefix;
    }
    set prefix(value) {
        if (value !== this._prefix) {
            this._prefix = value;
        }
    }
    get value() {
        return this._selectedEntities;
    }
    set value(value) {
        if (value !== this._selectedEntities) {
            this.valuesFormControl.setValue(value);
            this.setValue(value);
        }
    }
    get empty() {
        const n = this.valuesFormControl.value;
        return !n;
    }
    get shouldLabelFloat() {
        return this.focused || !this.empty;
    }
    ngOnInit() {
        this.ngControl = this.injector.get(NgControl, null);
        if (this.ngControl != null) {
            this.ngControl.valueAccessor = this;
        }
        // If prefix defined, usually this is used for a code scanner.
        // The goal is to select the entity in direct way.
        if (this._prefix) {
            this.searchFormControl.valueChanges
                .pipe(debounceTime(300), filter((value) => typeof value === 'string'), filter((value) => value.startsWith(this._prefix)), tap(() => (this.isLoading = true)), switchMap((value) => this._dataSource?.onFilter(value.replace(this._prefix, '').trim()) ?? of(null)))
                .subscribe((resultSet) => {
                if (resultSet?.list) {
                    this.filteredEntities = resultSet.list;
                }
                this.isLoading = false;
            });
        }
        // This is the search functionality when search by human.
        this.searchFormControl.valueChanges
            .pipe(debounceTime(300), tap(() => (this.filteredEntities = [])), filter((value) => typeof value === 'string'), filter((value) => value.toString().length >= 3), tap(() => (this.isLoading = true)), switchMap((value) => this._dataSource?.onFilter(value) ?? of(null)))
            .subscribe((resultSet) => {
            const resultList = new Array();
            if (resultSet?.list) {
                resultSet.list.forEach((value1) => {
                    if (!this.value?.find((value2) => this._dataSource?.getIdEntity(value2) === this._dataSource?.getIdEntity(value1))) {
                        resultList.push(value1);
                    }
                });
            }
            this.filteredEntities = resultList;
            this.isLoading = false;
        });
    }
    ngOnDestroy() {
        this.stateChanges.complete();
        this.fm.stopMonitoring(this.elRef.nativeElement);
    }
    ngDoCheck() {
        if (this.ngControl != null) {
            this.errorState = (this.ngControl.invalid && this.ngControl.touched) ?? false;
            this.stateChanges.next();
        }
    }
    clear() {
        this.filteredEntities = [];
        this.searchFormControl.reset(null);
    }
    focus() {
        this.elRef.nativeElement.querySelector('input')?.focus();
    }
    onEntitySelected(event) {
        let list = this.value;
        if (list == null) {
            list = new Array();
        }
        list.push(event.option.value);
        this.value = list;
        this.filteredEntities = [];
        this.searchFormControl.setValue(null);
        this.valuesFormControl.updateValueAndValidity();
    }
    onEntityActivated(event) {
        this.activatedValue = event.option?.value;
    }
    onEntityClosed() {
        if (this.activatedValue) {
            this.value = this.activatedValue;
            this.activatedValue = null;
        }
    }
    reset() {
        this.value = new Array();
    }
    onFocusOut() {
        // if (this.filteredEntities.length === 1) {
        //   this.activatedValue = this.filteredEntities[0];
        //   this.value = this.filteredEntities[0];
        // }
    }
    onTouched() {
        this._onTouched();
        this.stateChanges.next();
    }
    registerOnChange(fn) {
        this._propagateChange = fn;
    }
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    writeValue(obj) {
        this.clear();
        this.value = obj;
    }
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
    onContainerClick(event) {
        if (event.target.tagName.toLowerCase() !== 'input') {
            this.focus();
        }
    }
    setDescribedByIds(ids) {
        this.describedBy = ids.join(' ');
    }
    validate(control) {
        const selection = control.value;
        if (typeof selection === 'string') {
            return { incorrect: true };
        }
        return null;
    }
    remove(value) {
        const list = this.value;
        if (list != null) {
            const index = list.indexOf(value);
            if (index !== -1) {
                list.splice(index, 1);
            }
            this.valuesFormControl.updateValueAndValidity();
        }
    }
    _propagateChange = (_) => { };
    _onTouched = () => { };
    setValue(values) {
        if (values !== this._selectedEntities) {
            this._selectedEntities = values;
            this.valuesChange.emit(values ?? []);
            this._propagateChange(this._selectedEntities ?? []);
            this.stateChanges.next();
        }
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.14", ngImport: i0, type: MmMultipleEntitySelectInputComponent, deps: [{ token: i0.ElementRef }, { token: i0.Injector }, { token: i1$2.FocusMonitor }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.2.14", type: MmMultipleEntitySelectInputComponent, isStandalone: false, selector: "mm-multiple-entity-select", inputs: { dataSource: "dataSource", disabled: "disabled", placeholder: "placeholder", required: "required", prefix: "prefix" }, host: { properties: { "id": "this.id", "attr.aria-describedby": "this.describedBy", "class.floating": "this.shouldLabelFloat" } }, providers: [
            {
                provide: NG_VALUE_ACCESSOR,
                useExisting: forwardRef(() => MmMultipleEntitySelectInputComponent),
                multi: true
            },
            {
                provide: MatFormFieldControl,
                useExisting: MmMultipleEntitySelectInputComponent
            },
            {
                provide: NG_VALIDATORS,
                useExisting: forwardRef(() => MmMultipleEntitySelectInputComponent),
                multi: true
            }
        ], viewQueries: [{ propertyName: "inputField", first: true, predicate: ["input"], descendants: true }], ngImport: i0, template: "<mat-chip-grid #list>\n  <mat-chip-row *ngFor=\"let entity of valuesFormControl.value\"\n                (removed)=\"remove(entity)\"\n                [editable]=\"false\"\n                [aria-description]=\"'press enter to edit ' + dataSource?.onDisplayEntity(entity) ?? null\">\n    {{dataSource?.onDisplayEntity(entity) ?? null}}\n    <button matChipRemove [attr.aria-label]=\"'remove ' + dataSource?.onDisplayEntity(entity) ?? null\">\n      <mat-icon class=\"material-symbols-outlined\">cancel</mat-icon>\n    </button>\n  </mat-chip-row>\n  <input #input (blur)=\"onTouched()\" (focusout)=\"onFocusOut()\" [formControl]=\"searchFormControl\"\n         [matAutocomplete]=\"auto\"\n         [matChipInputFor]=\"list\"\n         matChipInputAddOnBlur=\"true\"\n         [matChipInputSeparatorKeyCodes]=\"separatorKeysCodes\"\n         [placeholder]=\"placeholder\" matInput>\n  <mat-autocomplete #auto=\"matAutocomplete\" (closed)=\"onEntityClosed()\"\n                    (optionActivated)=\"onEntityActivated($event)\" (optionSelected)=\"onEntitySelected($event)\"\n                    [displayWith]=\"dataSource?.onDisplayEntity ?? null\">\n    <mat-option *ngIf=\"isLoading\" class=\"is-loading\">\n      <mat-spinner diameter=\"50\"></mat-spinner>\n    </mat-option>\n    <ng-container *ngIf=\"!isLoading\">\n      <mat-option *ngFor=\"let entity of filteredEntities\" [value]=\"entity\">\n        {{dataSource?.onDisplayEntity(entity) ?? null}}\n      </mat-option>\n    </ng-container>\n  </mat-autocomplete>\n</mat-chip-grid>\n", styles: [""], dependencies: [{ kind: "directive", type: i2$1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: i3.MatAutocomplete, selector: "mat-autocomplete", inputs: ["aria-label", "aria-labelledby", "displayWith", "autoActiveFirstOption", "autoSelectActiveOption", "requireSelection", "panelWidth", "disableRipple", "class", "hideSingleSelectionIndicator"], outputs: ["optionSelected", "opened", "closed", "optionActivated"], exportAs: ["matAutocomplete"] }, { kind: "component", type: i3.MatOption, selector: "mat-option", inputs: ["value", "id", "disabled"], outputs: ["onSelectionChange"], exportAs: ["matOption"] }, { kind: "directive", type: i3.MatAutocompleteTrigger, selector: "input[matAutocomplete], textarea[matAutocomplete]", inputs: ["matAutocomplete", "matAutocompletePosition", "matAutocompleteConnectedTo", "autocomplete", "matAutocompleteDisabled"], exportAs: ["matAutocompleteTrigger"] }, { kind: "directive", type: i4$1.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly", "disabledInteractive"], exportAs: ["matInput"] }, { kind: "component", type: i5.MatProgressSpinner, selector: "mat-progress-spinner, mat-spinner", inputs: ["color", "mode", "value", "diameter", "strokeWidth"], exportAs: ["matProgressSpinner"] }, { kind: "component", type: i6$2.MatChipGrid, selector: "mat-chip-grid", inputs: ["disabled", "placeholder", "required", "value", "errorStateMatcher"], outputs: ["change", "valueChange"] }, { kind: "directive", type: i6$2.MatChipInput, selector: "input[matChipInputFor]", inputs: ["matChipInputFor", "matChipInputAddOnBlur", "matChipInputSeparatorKeyCodes", "placeholder", "id", "disabled"], outputs: ["matChipInputTokenEnd"], exportAs: ["matChipInput", "matChipInputFor"] }, { kind: "directive", type: i6$2.MatChipRemove, selector: "[matChipRemove]" }, { kind: "component", type: i6$2.MatChipRow, selector: "mat-chip-row, [mat-chip-row], mat-basic-chip-row, [mat-basic-chip-row]", inputs: ["editable"], outputs: ["edited"] }, { kind: "component", type: i6.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "directive", type: i6$1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i6$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i6$1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.14", ngImport: i0, type: MmMultipleEntitySelectInputComponent, decorators: [{
            type: Component,
            args: [{ selector: 'mm-multiple-entity-select', standalone: false, host: {
                        '[id]': 'id',
                        '[attr.aria-describedby]': 'describedBy'
                    }, providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef(() => MmMultipleEntitySelectInputComponent),
                            multi: true
                        },
                        {
                            provide: MatFormFieldControl,
                            useExisting: MmMultipleEntitySelectInputComponent
                        },
                        {
                            provide: NG_VALIDATORS,
                            useExisting: forwardRef(() => MmMultipleEntitySelectInputComponent),
                            multi: true
                        }
                    ], template: "<mat-chip-grid #list>\n  <mat-chip-row *ngFor=\"let entity of valuesFormControl.value\"\n                (removed)=\"remove(entity)\"\n                [editable]=\"false\"\n                [aria-description]=\"'press enter to edit ' + dataSource?.onDisplayEntity(entity) ?? null\">\n    {{dataSource?.onDisplayEntity(entity) ?? null}}\n    <button matChipRemove [attr.aria-label]=\"'remove ' + dataSource?.onDisplayEntity(entity) ?? null\">\n      <mat-icon class=\"material-symbols-outlined\">cancel</mat-icon>\n    </button>\n  </mat-chip-row>\n  <input #input (blur)=\"onTouched()\" (focusout)=\"onFocusOut()\" [formControl]=\"searchFormControl\"\n         [matAutocomplete]=\"auto\"\n         [matChipInputFor]=\"list\"\n         matChipInputAddOnBlur=\"true\"\n         [matChipInputSeparatorKeyCodes]=\"separatorKeysCodes\"\n         [placeholder]=\"placeholder\" matInput>\n  <mat-autocomplete #auto=\"matAutocomplete\" (closed)=\"onEntityClosed()\"\n                    (optionActivated)=\"onEntityActivated($event)\" (optionSelected)=\"onEntitySelected($event)\"\n                    [displayWith]=\"dataSource?.onDisplayEntity ?? null\">\n    <mat-option *ngIf=\"isLoading\" class=\"is-loading\">\n      <mat-spinner diameter=\"50\"></mat-spinner>\n    </mat-option>\n    <ng-container *ngIf=\"!isLoading\">\n      <mat-option *ngFor=\"let entity of filteredEntities\" [value]=\"entity\">\n        {{dataSource?.onDisplayEntity(entity) ?? null}}\n      </mat-option>\n    </ng-container>\n  </mat-autocomplete>\n</mat-chip-grid>\n" }]
        }], ctorParameters: () => [{ type: i0.ElementRef }, { type: i0.Injector }, { type: i1$2.FocusMonitor }], propDecorators: { id: [{
                type: HostBinding
            }], inputField: [{
                type: ViewChild,
                args: ['input']
            }], describedBy: [{
                type: HostBinding,
                args: ['attr.aria-describedby']
            }], dataSource: [{
                type: Input
            }], disabled: [{
                type: Input
            }], placeholder: [{
                type: Input
            }], required: [{
                type: Input
            }], prefix: [{
                type: Input
            }], shouldLabelFloat: [{
                type: HostBinding,
                args: ['class.floating']
            }] } });

class BreadcrumbData {
    constructor(label, labelTemplate, url) {
        this.label = label;
        this.labelTemplate = labelTemplate;
        this.url = url;
    }
    label;
    labelTemplate;
    url;
}

class MmBreadcrumbComponent {
    activatedRoute;
    router;
    breadcrumbService;
    breadcrumbData = [];
    fontSize = '18px';
    fontColor = '#0275d8';
    lastLinkColor = '#000';
    symbol = ' / ';
    constructor(activatedRoute, router, breadcrumbService) {
        this.activatedRoute = activatedRoute;
        this.router = router;
        this.breadcrumbService = breadcrumbService;
        this.breadCrumbData();
    }
    ngOnInit() {
        this.breadcrumbService.breadcrumbLabels.subscribe((labelData) => {
            Object.entries(labelData).forEach(([key, value]) => {
                this.breadcrumbData.forEach((breadcrumbData) => {
                    const labelParams = breadcrumbData.labelTemplate.match(/[^{{]+(?=}})/g);
                    if (labelParams) {
                        for (const labelParam of labelParams) {
                            if (labelParam === key) {
                                breadcrumbData.label = breadcrumbData.labelTemplate.replace('{{' + labelParam + '}}', value);
                            }
                        }
                    }
                });
            });
        });
        this.breadcrumbService.newBreadcrumb.subscribe((breadcrumb) => {
            if (breadcrumb.length > 0) {
                this.updateData(this.activatedRoute, breadcrumb);
            }
        });
    }
    breadCrumbData() {
        this.router.events
            .pipe(filter((event) => event instanceof NavigationEnd))
            .pipe(map(() => this.activatedRoute))
            .pipe(map((route) => {
            while (route.firstChild) {
                route = route.firstChild;
            }
            return route;
        }))
            .pipe(filter((route) => route.outlet === PRIMARY_OUTLET))
            .subscribe((route) => {
            this.updateData(route, null);
        });
    }
    updateData(route, newBreadcrumb) {
        if (route.snapshot.data['breadcrumb'] || newBreadcrumb) {
            const data = route.snapshot.data['breadcrumb'] ? route.snapshot.data['breadcrumb'] : newBreadcrumb;
            const breadcrumb = JSON.parse(JSON.stringify(data));
            const breadcrumbData = new Array();
            breadcrumb.forEach((crumb) => {
                const breadcrumbDataItem = new BreadcrumbData(crumb.label, crumb.label, crumb.url);
                breadcrumbData.push(breadcrumbDataItem);
                if (breadcrumbDataItem.url) {
                    const urlChunks = breadcrumbDataItem.url.split('/');
                    for (const chunk of urlChunks) {
                        if (chunk.includes(':')) {
                            const paramID = chunk.replace(':', '');
                            const routerParamID = route.snapshot.params[paramID];
                            breadcrumbDataItem.url = crumb.url.replace(`:${paramID}`, routerParamID);
                        }
                    }
                }
                const labelParams = breadcrumbDataItem.labelTemplate.match(/[^{{]+(?=}})/g);
                if (labelParams) {
                    for (const labelParam of labelParams) {
                        const routerParamID = decodeURIComponent(route.snapshot.params[labelParam.trim()]);
                        if (routerParamID) {
                            breadcrumbDataItem.label = breadcrumbDataItem.labelTemplate.replace('{{' + labelParam + '}}', routerParamID);
                        }
                        else {
                            breadcrumbDataItem.label = breadcrumbDataItem.labelTemplate.replace('{{' + labelParam + '}}', '');
                        }
                    }
                }
            });
            this.breadcrumbData = breadcrumbData;
        }
        else {
            this.breadcrumbData = [];
        }
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.14", ngImport: i0, type: MmBreadcrumbComponent, deps: [{ token: i1$3.ActivatedRoute }, { token: i1$3.Router }, { token: i1$1.BreadcrumbService }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.2.14", type: MmBreadcrumbComponent, isStandalone: false, selector: "mm-breadcrumb", inputs: { fontSize: "fontSize", fontColor: "fontColor", lastLinkColor: "lastLinkColor", symbol: "symbol" }, ngImport: i0, template: "<mat-list class=\"mat-bread-crumb-list\" *ngIf=\"breadcrumbData.length\">\n  <mat-list-item>\n      <span class=\"mat-bread-crumb-spacer\">\n          <span *ngFor=\"let item of breadcrumbData; let i = index\">\n              <a *ngIf=\"item?.url\" [routerLink]=\"item?.url\"\n                 class=\"mat-bread-crumb-list-item\">{{ item.label }}</a>\n              <span *ngIf=\"!item?.url\" class=\"mat-bread-crumb-list-item\">{{ item.label }}</span>\n              <span *ngIf=\"breadcrumbData.length !== i+1\" class=\"mat-bread-crumb-list-item\">{{symbol}}</span>\n          </span>\n      </span>\n  </mat-list-item>\n</mat-list>\n", styles: [".mat-bread-crumb{height:30px}.mat-bread-crumb-list{padding-bottom:10px}\n"], dependencies: [{ kind: "directive", type: i2$1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: i4$2.MatList, selector: "mat-list", exportAs: ["matList"] }, { kind: "component", type: i4$2.MatListItem, selector: "mat-list-item, a[mat-list-item], button[mat-list-item]", inputs: ["activated"], exportAs: ["matListItem"] }, { kind: "directive", type: i1$3.RouterLink, selector: "[routerLink]", inputs: ["target", "queryParams", "fragment", "queryParamsHandling", "state", "info", "relativeTo", "preserveFragment", "skipLocationChange", "replaceUrl", "routerLink"] }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.14", ngImport: i0, type: MmBreadcrumbComponent, decorators: [{
            type: Component,
            args: [{ selector: 'mm-breadcrumb', standalone: false, template: "<mat-list class=\"mat-bread-crumb-list\" *ngIf=\"breadcrumbData.length\">\n  <mat-list-item>\n      <span class=\"mat-bread-crumb-spacer\">\n          <span *ngFor=\"let item of breadcrumbData; let i = index\">\n              <a *ngIf=\"item?.url\" [routerLink]=\"item?.url\"\n                 class=\"mat-bread-crumb-list-item\">{{ item.label }}</a>\n              <span *ngIf=\"!item?.url\" class=\"mat-bread-crumb-list-item\">{{ item.label }}</span>\n              <span *ngIf=\"breadcrumbData.length !== i+1\" class=\"mat-bread-crumb-list-item\">{{symbol}}</span>\n          </span>\n      </span>\n  </mat-list-item>\n</mat-list>\n", styles: [".mat-bread-crumb{height:30px}.mat-bread-crumb-list{padding-bottom:10px}\n"] }]
        }], ctorParameters: () => [{ type: i1$3.ActivatedRoute }, { type: i1$3.Router }, { type: i1$1.BreadcrumbService }], propDecorators: { fontSize: [{
                type: Input
            }], fontColor: [{
                type: Input
            }], lastLinkColor: [{
                type: Input
            }], symbol: [{
                type: Input
            }] } });

var ButtonTypes;
(function (ButtonTypes) {
    ButtonTypes[ButtonTypes["Ok"] = 0] = "Ok";
    ButtonTypes[ButtonTypes["Cancel"] = 1] = "Cancel";
    ButtonTypes[ButtonTypes["Yes"] = 2] = "Yes";
    ButtonTypes[ButtonTypes["No"] = 3] = "No";
})(ButtonTypes || (ButtonTypes = {}));
var DialogType;
(function (DialogType) {
    DialogType[DialogType["YesNo"] = 0] = "YesNo";
    DialogType[DialogType["YesNoCancel"] = 1] = "YesNoCancel";
    DialogType[DialogType["OkCancel"] = 2] = "OkCancel";
    DialogType[DialogType["Ok"] = 3] = "Ok";
})(DialogType || (DialogType = {}));

class MmConfirmationWindowComponent {
    dialogRef;
    data;
    button1Text;
    button1Result;
    button2Text;
    button2Result;
    button3Text;
    button3Result;
    constructor(dialogRef, data) {
        this.dialogRef = dialogRef;
        this.data = data;
        this.button2Text = null;
        this.button2Result = null;
        this.button3Text = null;
        this.button3Result = null;
        if (data.dialogType === DialogType.OkCancel) {
            this.button1Text = 'OK';
            this.button1Result = ButtonTypes.Ok;
            this.button2Text = 'Cancel';
            this.button2Result = ButtonTypes.Cancel;
        }
        else if (data.dialogType === DialogType.YesNoCancel) {
            this.button1Text = 'Yes';
            this.button1Result = ButtonTypes.Yes;
            this.button2Text = 'No';
            this.button2Result = ButtonTypes.No;
            this.button3Text = 'Cancel';
            this.button3Result = ButtonTypes.Cancel;
        }
        else if (data.dialogType === DialogType.Ok) {
            this.button1Text = 'OK';
            this.button1Result = ButtonTypes.Ok;
        }
        else {
            this.button1Text = 'Yes';
            this.button1Result = ButtonTypes.Yes;
            this.button2Text = 'No';
            this.button2Result = ButtonTypes.No;
        }
    }
    ngOnInit() { }
    onButton1() {
        this.dialogRef.close({
            result: this.button1Result
        });
    }
    onButton2() {
        this.dialogRef.close({
            result: this.button2Result
        });
    }
    onButton3() {
        this.dialogRef.close({
            result: this.button3Result
        });
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.14", ngImport: i0, type: MmConfirmationWindowComponent, deps: [{ token: i1.MatDialogRef }, { token: MAT_DIALOG_DATA }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.2.14", type: MmConfirmationWindowComponent, isStandalone: false, selector: "mm-confirmation-window", ngImport: i0, template: "<h1 mat-dialog-title>{{data.title}}</h1>\n<div mat-dialog-content>{{data.message}}</div>\n<div style=\"justify-content: flex-end;\" mat-dialog-actions>\n  <button (click)=\"onButton1()\" class=\"primary-button\" mat-flat-button>{{button1Text}}</button>\n  <button (click)=\"onButton2()\" *ngIf=\"button2Text\" mat-flat-button>{{button2Text}}</button>\n  <button (click)=\"onButton3()\" *ngIf=\"button3Text\" mat-flat-button>{{button3Text}}</button>\n</div>\n", styles: [""], dependencies: [{ kind: "directive", type: i2$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: i2.MatButton, selector: "    button[mat-button], button[mat-raised-button], button[mat-flat-button],    button[mat-stroked-button]  ", exportAs: ["matButton"] }, { kind: "directive", type: i1.MatDialogTitle, selector: "[mat-dialog-title], [matDialogTitle]", inputs: ["id"], exportAs: ["matDialogTitle"] }, { kind: "directive", type: i1.MatDialogActions, selector: "[mat-dialog-actions], mat-dialog-actions, [matDialogActions]", inputs: ["align"] }, { kind: "directive", type: i1.MatDialogContent, selector: "[mat-dialog-content], mat-dialog-content, [matDialogContent]" }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.14", ngImport: i0, type: MmConfirmationWindowComponent, decorators: [{
            type: Component,
            args: [{ selector: 'mm-confirmation-window', standalone: false, template: "<h1 mat-dialog-title>{{data.title}}</h1>\n<div mat-dialog-content>{{data.message}}</div>\n<div style=\"justify-content: flex-end;\" mat-dialog-actions>\n  <button (click)=\"onButton1()\" class=\"primary-button\" mat-flat-button>{{button1Text}}</button>\n  <button (click)=\"onButton2()\" *ngIf=\"button2Text\" mat-flat-button>{{button2Text}}</button>\n  <button (click)=\"onButton3()\" *ngIf=\"button3Text\" mat-flat-button>{{button3Text}}</button>\n</div>\n" }]
        }], ctorParameters: () => [{ type: i1.MatDialogRef }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [MAT_DIALOG_DATA]
                }] }] });

class MmProgressWindowComponent {
    data;
    statusText;
    progressValue;
    constructor(data) {
        this.data = data;
        this.statusText = null;
        this.progressValue = 0;
        data.progress.subscribe((value) => {
            this.statusText = value.statusText;
            this.progressValue = value.progressValue;
        });
    }
    ngOnInit() { }
    onCancelClick() {
        this.data.cancelOperation();
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.14", ngImport: i0, type: MmProgressWindowComponent, deps: [{ token: MAT_DIALOG_DATA }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.2.14", type: MmProgressWindowComponent, isStandalone: false, selector: "mm-progress-window", ngImport: i0, template: "<h1 mat-dialog-title>{{data.title}}</h1>\n<div mat-dialog-content>\n  <div>\n    <mat-progress-bar *ngIf=\"data.isDeterminate\" [value]=\"progressValue\" mode=\"determinate\"></mat-progress-bar>\n    <mat-progress-bar *ngIf=\"!data.isDeterminate\" mode=\"indeterminate\"></mat-progress-bar>\n    <p>{{statusText}}</p>\n  </div>\n</div>\n<div style=\"justify-content: flex-end;\" mat-dialog-actions>\n  <button (click)=\"onCancelClick()\" *ngIf=\"data.isCancelOperationAvailable\" mat-button>Cancel</button>\n</div>\n", styles: [""], dependencies: [{ kind: "directive", type: i2$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: i2.MatButton, selector: "    button[mat-button], button[mat-raised-button], button[mat-flat-button],    button[mat-stroked-button]  ", exportAs: ["matButton"] }, { kind: "directive", type: i1.MatDialogTitle, selector: "[mat-dialog-title], [matDialogTitle]", inputs: ["id"], exportAs: ["matDialogTitle"] }, { kind: "directive", type: i1.MatDialogActions, selector: "[mat-dialog-actions], mat-dialog-actions, [matDialogActions]", inputs: ["align"] }, { kind: "directive", type: i1.MatDialogContent, selector: "[mat-dialog-content], mat-dialog-content, [matDialogContent]" }, { kind: "component", type: i4$3.MatProgressBar, selector: "mat-progress-bar", inputs: ["color", "value", "bufferValue", "mode"], outputs: ["animationEnd"], exportAs: ["matProgressBar"] }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.14", ngImport: i0, type: MmProgressWindowComponent, decorators: [{
            type: Component,
            args: [{ selector: 'mm-progress-window', standalone: false, template: "<h1 mat-dialog-title>{{data.title}}</h1>\n<div mat-dialog-content>\n  <div>\n    <mat-progress-bar *ngIf=\"data.isDeterminate\" [value]=\"progressValue\" mode=\"determinate\"></mat-progress-bar>\n    <mat-progress-bar *ngIf=\"!data.isDeterminate\" mode=\"indeterminate\"></mat-progress-bar>\n    <p>{{statusText}}</p>\n  </div>\n</div>\n<div style=\"justify-content: flex-end;\" mat-dialog-actions>\n  <button (click)=\"onCancelClick()\" *ngIf=\"data.isCancelOperationAvailable\" mat-button>Cancel</button>\n</div>\n" }]
        }], ctorParameters: () => [{ type: undefined, decorators: [{
                    type: Inject,
                    args: [MAT_DIALOG_DATA]
                }] }] });

class ConfirmationService {
    dialog;
    constructor(dialog) {
        this.dialog = dialog;
    }
    showYesNoConfirmationDialog(title, message) {
        const dialogRef = this.dialog.open(MmConfirmationWindowComponent, {
            width: '50vw',
            maxWidth: '50vw',
            data: {
                title,
                message,
                dialogType: DialogType.YesNo
            }
        });
        return dialogRef.afterClosed().pipe(map((value) => value?.result === ButtonTypes.Yes));
    }
    showYesNoCancelConfirmationDialog(title, message) {
        const dialogRef = this.dialog.open(MmConfirmationWindowComponent, {
            width: '50vw',
            maxWidth: '50vw',
            data: {
                title,
                message,
                dialogType: DialogType.YesNoCancel
            }
        });
        return dialogRef.afterClosed();
    }
    showOkCancelConfirmationDialog(title, message) {
        const dialogRef = this.dialog.open(MmConfirmationWindowComponent, {
            width: '50vw',
            maxWidth: '50vw',
            data: {
                title,
                message,
                dialogType: DialogType.OkCancel
            }
        });
        return dialogRef.afterClosed().pipe(map((value) => value?.result === ButtonTypes.Ok));
    }
    showOkDialog(title, message) {
        const dialogRef = this.dialog.open(MmConfirmationWindowComponent, {
            width: '50vw',
            maxWidth: '50vw',
            data: {
                title,
                message,
                dialogType: DialogType.Ok
            }
        });
        return dialogRef.afterClosed().pipe(map((value) => value?.result === ButtonTypes.Ok));
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.14", ngImport: i0, type: ConfirmationService, deps: [{ token: i1.MatDialog }], target: i0.ɵɵFactoryTarget.Injectable });
    static ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.2.14", ngImport: i0, type: ConfirmationService, providedIn: 'root' });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.14", ngImport: i0, type: ConfirmationService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: () => [{ type: i1.MatDialog }] });

class ProgressNotifierService {
    dialog;
    _currentProgressValue;
    currentDialogRef;
    constructor(dialog) {
        this.dialog = dialog;
        this._currentProgressValue = new BehaviorSubject(null);
        this.currentDialogRef = null;
        this._isCanceled = false;
    }
    _isCanceled;
    get isCanceled() {
        return this._isCanceled;
    }
    set isCanceled(value) {
        this._isCanceled = value;
    }
    start(title, isDeterminate, isCancelOperationAvailable) {
        this.isCanceled = false;
        this.reportProgressDeterminate(0, 100, 'Working...');
        this.currentDialogRef = this.dialog.open(MmProgressWindowComponent, {
            width: '50vw',
            maxWidth: '50vw',
            data: {
                title,
                isDeterminate,
                progress: this._currentProgressValue.asObservable(),
                isCancelOperationAvailable,
                cancelOperation: () => {
                    this.reportProgressIndeterminate('Canceling operation...');
                    this.isCanceled = true;
                }
            }
        });
    }
    reportProgressDeterminate(progressCurrent, progressMax, statusText) {
        const progressPercentage = (progressMax / 100) * progressCurrent;
        this._currentProgressValue.next({
            statusText,
            progressValue: progressPercentage
        });
    }
    reportProgressIndeterminate(statusText) {
        this._currentProgressValue.next({
            statusText,
            progressValue: 0
        });
    }
    complete() {
        this.currentDialogRef?.close();
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.14", ngImport: i0, type: ProgressNotifierService, deps: [{ token: i1.MatDialog }], target: i0.ɵɵFactoryTarget.Injectable });
    static ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.2.14", ngImport: i0, type: ProgressNotifierService });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.14", ngImport: i0, type: ProgressNotifierService, decorators: [{
            type: Injectable
        }], ctorParameters: () => [{ type: i1.MatDialog }] });

class MmFileUploadComponent {
    dialogRef;
    data;
    snackBar;
    fileName = signal('');
    fileSize = signal(0);
    uploadProgress = signal(0);
    fileInput;
    selectedFile = null;
    uploadSuccess;
    uploadError;
    constructor(dialogRef, data, snackBar) {
        this.dialogRef = dialogRef;
        this.data = data;
        this.snackBar = snackBar;
        this.uploadError = false;
        this.uploadSuccess = false;
    }
    // Handler for file input change
    onFileChange(event) {
        const file = event.target.files[0];
        this.uploadFile(file);
    }
    // Handler for the file drop
    onFileDrop(event) {
        event.preventDefault();
        const file = event.dataTransfer?.files[0];
        this.uploadFile(file);
    }
    // Prevent default dragover behavior
    onDragOver(event) {
        event.preventDefault();
    }
    // Method to handle file upload
    uploadFile(file) {
        const allowedMimeTypes = this.data.mimeTypes.split(',').map((mimeType) => mimeType.trim());
        const allowedFileExtensions = this.data.fileExtensions?.split(',').map((mimeType) => mimeType.trim()) ?? [];
        if (!file) {
            return;
        }
        console.log("type: " + file.type);
        console.log("name: " + file.name);
        const extension = file.name.substring(file.name.lastIndexOf('.')).toLowerCase();
        console.log("extension: " + extension);
        if (allowedFileExtensions.includes(extension) || allowedMimeTypes.includes(file.type)) {
            this.selectedFile = file;
            this.fileSize.set(Math.round(file.size / 1024)); // Set file size in KB
            this.uploadSuccess = true;
            this.uploadError = false;
            this.fileName.set(file.name); // Set image name
        }
        else {
            this.uploadSuccess = false;
            this.uploadError = true;
            this.snackBar.open('File type not supported!', 'Close', {
                duration: 3000,
                panelClass: 'error',
            });
        }
    }
    // Method to remove a file
    removeFile() {
        this.selectedFile = null;
        this.fileName.set('');
        this.fileSize.set(0);
        this.uploadSuccess = false;
        this.uploadError = false;
        this.uploadProgress.set(0);
    }
    onOk() {
        this.dialogRef.close({
            success: true,
            selectedFile: this.selectedFile
        });
    }
    onCancel() {
        this.dialogRef.close({
            success: false,
            selectedFile: null
        });
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.14", ngImport: i0, type: MmFileUploadComponent, deps: [{ token: i1.MatDialogRef }, { token: MAT_DIALOG_DATA }, { token: i2$2.MatSnackBar }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.2.14", type: MmFileUploadComponent, isStandalone: false, selector: "mm-mm-file-upload", viewQueries: [{ propertyName: "fileInput", first: true, predicate: ["fileInput"], descendants: true }], ngImport: i0, template: "<h1 mat-dialog-title>{{data.title}}</h1>\n<div\n  class=\"file-upload-wrapper\"\n  [class.success]=\"uploadSuccess\"\n  [class.error]=\"uploadError\"\n  (drop)=\"onFileDrop($event)\"\n  (dragover)=\"onDragOver($event)\"\n>\n  <input\n    type=\"file\"\n    accept=\"{{data.fileExtensions}}\"\n    (change)=\"onFileChange($event)\"\n    hidden\n    #fileInput\n  />\n  <div class=\"file-dropper\" (click)=\"fileInput.click()\">\n    <mat-icon class=\"material-symbols-outlined\">upload</mat-icon>\n    <p>{{data.message}}</p>\n    <div *ngIf=\"fileName()\">\n      <div *ngIf=\"selectedFile\">\n        <p>\n          <span class=\"image-name\">{{ fileName() }}</span> ({{\n            fileSize()\n          }} KB)\n        </p>\n        <mat-icon class=\"material-symbols-outlined delete-icon\" (click)=\"removeFile()\">delete</mat-icon>\n      </div>\n    </div>\n  </div>\n</div>\n<div style=\"justify-content: flex-end;\" mat-dialog-actions>\n  <button (click)=\"onOk()\" [disabled]=\"!selectedFile\" mat-flat-button>Upload</button>\n  <button (click)=\"onCancel()\" mat-button>Cancel</button>\n</div>\n\n", styles: [".file-upload-wrapper{display:flex;justify-content:center;align-items:center;flex-direction:column;border:2px dashed #ccc;padding:1rem;margin-bottom:1rem;margin-left:1rem;margin-right:1rem;border-radius:10px;cursor:pointer}.file-upload-wrapper.success{border-color:green}.file-upload-wrapper.error{border-color:red}.file-dropper{display:flex;flex-direction:column;align-items:center}.image-name{font-weight:700}.image-preview{max-width:100%;height:auto;margin-bottom:.5rem;border-radius:10px}.delete-icon{cursor:pointer;color:red}\n"], dependencies: [{ kind: "directive", type: i2$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: i2.MatButton, selector: "    button[mat-button], button[mat-raised-button], button[mat-flat-button],    button[mat-stroked-button]  ", exportAs: ["matButton"] }, { kind: "directive", type: i1.MatDialogTitle, selector: "[mat-dialog-title], [matDialogTitle]", inputs: ["id"], exportAs: ["matDialogTitle"] }, { kind: "directive", type: i1.MatDialogActions, selector: "[mat-dialog-actions], mat-dialog-actions, [matDialogActions]", inputs: ["align"] }, { kind: "component", type: i6.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.14", ngImport: i0, type: MmFileUploadComponent, decorators: [{
            type: Component,
            args: [{ selector: 'mm-mm-file-upload', standalone: false, template: "<h1 mat-dialog-title>{{data.title}}</h1>\n<div\n  class=\"file-upload-wrapper\"\n  [class.success]=\"uploadSuccess\"\n  [class.error]=\"uploadError\"\n  (drop)=\"onFileDrop($event)\"\n  (dragover)=\"onDragOver($event)\"\n>\n  <input\n    type=\"file\"\n    accept=\"{{data.fileExtensions}}\"\n    (change)=\"onFileChange($event)\"\n    hidden\n    #fileInput\n  />\n  <div class=\"file-dropper\" (click)=\"fileInput.click()\">\n    <mat-icon class=\"material-symbols-outlined\">upload</mat-icon>\n    <p>{{data.message}}</p>\n    <div *ngIf=\"fileName()\">\n      <div *ngIf=\"selectedFile\">\n        <p>\n          <span class=\"image-name\">{{ fileName() }}</span> ({{\n            fileSize()\n          }} KB)\n        </p>\n        <mat-icon class=\"material-symbols-outlined delete-icon\" (click)=\"removeFile()\">delete</mat-icon>\n      </div>\n    </div>\n  </div>\n</div>\n<div style=\"justify-content: flex-end;\" mat-dialog-actions>\n  <button (click)=\"onOk()\" [disabled]=\"!selectedFile\" mat-flat-button>Upload</button>\n  <button (click)=\"onCancel()\" mat-button>Cancel</button>\n</div>\n\n", styles: [".file-upload-wrapper{display:flex;justify-content:center;align-items:center;flex-direction:column;border:2px dashed #ccc;padding:1rem;margin-bottom:1rem;margin-left:1rem;margin-right:1rem;border-radius:10px;cursor:pointer}.file-upload-wrapper.success{border-color:green}.file-upload-wrapper.error{border-color:red}.file-dropper{display:flex;flex-direction:column;align-items:center}.image-name{font-weight:700}.image-preview{max-width:100%;height:auto;margin-bottom:.5rem;border-radius:10px}.delete-icon{cursor:pointer;color:red}\n"] }]
        }], ctorParameters: () => [{ type: i1.MatDialogRef }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [MAT_DIALOG_DATA]
                }] }, { type: i2$2.MatSnackBar }], propDecorators: { fileInput: [{
                type: ViewChild,
                args: ['fileInput']
            }] } });

class FileUploadService {
    dialog;
    constructor(dialog) {
        this.dialog = dialog;
    }
    async showUploadDialog(title, message, mimeTypes, fileExtensions = null) {
        const dialogRef = this.dialog.open(MmFileUploadComponent, {
            width: '50vw',
            maxWidth: '50vw',
            data: {
                title,
                message,
                mimeTypes,
                fileExtensions
            }
        });
        const r = await firstValueFrom(dialogRef.afterClosed());
        const success = r?.success ?? false;
        if (success) {
            return r?.selectedFile ?? null;
        }
        return null;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.14", ngImport: i0, type: FileUploadService, deps: [{ token: i1.MatDialog }], target: i0.ɵɵFactoryTarget.Injectable });
    static ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.2.14", ngImport: i0, type: FileUploadService, providedIn: 'root' });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.14", ngImport: i0, type: FileUploadService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: () => [{ type: i1.MatDialog }] });

class MmTableSimpleComponent {
    sortColumn = '';
    items = [];
    columns = [];
    get displayedColumns() {
        return this.columns.map(col => col.key);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.14", ngImport: i0, type: MmTableSimpleComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.2.14", type: MmTableSimpleComponent, isStandalone: true, selector: "mm-table-simple", inputs: { sortColumn: "sortColumn", items: "items", columns: "columns" }, ngImport: i0, template: "<div>\n  <table mat-table [dataSource]=\"items\" matSort matSortActive=\"{{sortColumn}}\" matSortDirection=\"asc\" matSortDisableClear>\n\n    <!-- Dynamic Column Definitions -->\n    <ng-container *ngFor=\"let column of columns\" [matColumnDef]=\"column.key\">\n      <th mat-header-cell *matHeaderCellDef mat-sort-header>{{ column.header }}</th>\n      <td mat-cell *matCellDef=\"let element\">{{ element[column.key] }}</td>\n    </ng-container>\n\n    <!-- Header Row -->\n    <tr mat-header-row *matHeaderRowDef=\"displayedColumns\"></tr>\n    <!-- Data Rows -->\n    <tr mat-row *matRowDef=\"let row; columns: displayedColumns;\"></tr>\n  </table>\n</div>\n", styles: [""], dependencies: [{ kind: "component", type: MatTable, selector: "mat-table, table[mat-table]", exportAs: ["matTable"] }, { kind: "directive", type: MatColumnDef, selector: "[matColumnDef]", inputs: ["matColumnDef"] }, { kind: "directive", type: MatHeaderCell, selector: "mat-header-cell, th[mat-header-cell]" }, { kind: "directive", type: MatCell, selector: "mat-cell, td[mat-cell]" }, { kind: "component", type: MatHeaderRow, selector: "mat-header-row, tr[mat-header-row]", exportAs: ["matHeaderRow"] }, { kind: "component", type: MatRow, selector: "mat-row, tr[mat-row]", exportAs: ["matRow"] }, { kind: "directive", type: MatHeaderRowDef, selector: "[matHeaderRowDef]", inputs: ["matHeaderRowDef", "matHeaderRowDefSticky"] }, { kind: "directive", type: MatRowDef, selector: "[matRowDef]", inputs: ["matRowDefColumns", "matRowDefWhen"] }, { kind: "directive", type: MatHeaderCellDef, selector: "[matHeaderCellDef]" }, { kind: "directive", type: MatCellDef, selector: "[matCellDef]" }, { kind: "directive", type: NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: MatSort, selector: "[matSort]", inputs: ["matSortActive", "matSortStart", "matSortDirection", "matSortDisableClear", "matSortDisabled"], outputs: ["matSortChange"], exportAs: ["matSort"] }, { kind: "component", type: MatSortHeader, selector: "[mat-sort-header]", inputs: ["mat-sort-header", "arrowPosition", "start", "disabled", "sortActionDescription", "disableClear"], exportAs: ["matSortHeader"] }, { kind: "ngmodule", type: MatFormFieldModule }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.14", ngImport: i0, type: MmTableSimpleComponent, decorators: [{
            type: Component,
            args: [{ selector: 'mm-table-simple', standalone: true, imports: [
                        MatTable,
                        MatColumnDef,
                        MatHeaderCell,
                        MatCell,
                        MatHeaderRow,
                        MatRow,
                        MatHeaderRowDef,
                        MatRowDef,
                        MatHeaderCellDef,
                        MatCellDef,
                        NgForOf,
                        MatSort,
                        MatSortHeader,
                        MatFormFieldModule
                    ], template: "<div>\n  <table mat-table [dataSource]=\"items\" matSort matSortActive=\"{{sortColumn}}\" matSortDirection=\"asc\" matSortDisableClear>\n\n    <!-- Dynamic Column Definitions -->\n    <ng-container *ngFor=\"let column of columns\" [matColumnDef]=\"column.key\">\n      <th mat-header-cell *matHeaderCellDef mat-sort-header>{{ column.header }}</th>\n      <td mat-cell *matCellDef=\"let element\">{{ element[column.key] }}</td>\n    </ng-container>\n\n    <!-- Header Row -->\n    <tr mat-header-row *matHeaderRowDef=\"displayedColumns\"></tr>\n    <!-- Data Rows -->\n    <tr mat-row *matRowDef=\"let row; columns: displayedColumns;\"></tr>\n  </table>\n</div>\n" }]
        }], propDecorators: { sortColumn: [{
                type: Input
            }], items: [{
                type: Input
            }], columns: [{
                type: Input
            }] } });

class MmSharedUiModule {
    static forRoot() {
        return {
            ngModule: MmSharedUiModule,
            providers: [
                FileUploadService,
                ConfirmationService,
                ProgressNotifierService
            ]
        };
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.14", ngImport: i0, type: MmSharedUiModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
    static ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "19.2.14", ngImport: i0, type: MmSharedUiModule, declarations: [MmBreadcrumbComponent,
            MmConfirmationWindowComponent,
            MmProgressWindowComponent,
            MmNotificationBarComponent,
            MmMessageDetailsComponent,
            MmAutocompleteInputComponent,
            MmEntitySelectInputComponent,
            MmMultipleEntitySelectInputComponent,
            MmFileUploadComponent], imports: [CommonModule,
            MatToolbarModule,
            MatButtonModule,
            MatSnackBarModule,
            MatDialogModule,
            MatAutocompleteModule,
            MatInputModule,
            MatProgressSpinnerModule,
            MatChipsModule,
            MatIconModule,
            ReactiveFormsModule,
            MatIcon,
            MatListModule,
            RouterLink,
            MmTableSimpleComponent,
            MatProgressBar], exports: [MmBreadcrumbComponent,
            MmConfirmationWindowComponent,
            MmNotificationBarComponent,
            MmAutocompleteInputComponent,
            MmEntitySelectInputComponent,
            MmMultipleEntitySelectInputComponent,
            MmFileUploadComponent,
            MmTableSimpleComponent] });
    static ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "19.2.14", ngImport: i0, type: MmSharedUiModule, imports: [CommonModule,
            MatToolbarModule,
            MatButtonModule,
            MatSnackBarModule,
            MatDialogModule,
            MatAutocompleteModule,
            MatInputModule,
            MatProgressSpinnerModule,
            MatChipsModule,
            MatIconModule,
            ReactiveFormsModule,
            MatIcon,
            MatListModule,
            MmTableSimpleComponent,
            MatProgressBar] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.14", ngImport: i0, type: MmSharedUiModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        MmBreadcrumbComponent,
                        MmConfirmationWindowComponent,
                        MmProgressWindowComponent,
                        MmNotificationBarComponent,
                        MmMessageDetailsComponent,
                        MmAutocompleteInputComponent,
                        MmEntitySelectInputComponent,
                        MmMultipleEntitySelectInputComponent,
                        MmFileUploadComponent
                    ],
                    exports: [
                        MmBreadcrumbComponent,
                        MmConfirmationWindowComponent,
                        MmNotificationBarComponent,
                        MmAutocompleteInputComponent,
                        MmEntitySelectInputComponent,
                        MmMultipleEntitySelectInputComponent,
                        MmFileUploadComponent,
                        MmTableSimpleComponent
                    ],
                    imports: [
                        CommonModule,
                        MatToolbarModule,
                        MatButtonModule,
                        MatSnackBarModule,
                        MatDialogModule,
                        MatAutocompleteModule,
                        MatInputModule,
                        MatProgressSpinnerModule,
                        MatChipsModule,
                        MatIconModule,
                        ReactiveFormsModule,
                        MatIcon,
                        MatListModule,
                        RouterLink,
                        MmTableSimpleComponent,
                        MatProgressBar
                    ]
                }]
        }] });

function isEmptyInputValue(value) {
    // we don't check for string here so it also works with arrays
    return value == null || value.length === 0;
}
class CommonValidators {
    static phoneNumber() {
        return Validators.pattern('^[+]*[(]{0,1}[0-9]{1,4}[)]{0,1}[-\\s\\./0-9]*$');
    }
    static httpUri() {
        return Validators.pattern('^(http:\\/\\/|https:\\/\\/)([a-zA-Z0-9-_]+\\.)*[a-zA-Z0-9][a-zA-Z0-9-_]+(\\.[a-zA-Z]{2,11}?)*(:[0-9]{2,5}){0,1}\\/{0,1}$');
    }
    static ensureSameValue(sourceControlName) {
        return (control) => {
            const value = control.value;
            return value === control.parent?.get(sourceControlName)?.value ? null : { notSame: true };
        };
    }
    static conditionalRequired(sourceControlName, sourceValueCompareExpression) {
        return (control) => {
            if (control.parent != null && sourceValueCompareExpression(control.parent.get(sourceControlName)?.value)) {
                return isEmptyInputValue(control.value) ? { required: true } : null;
            }
            return null;
        };
    }
    static dependentControls(controlNames) {
        return (control) => {
            controlNames.forEach((controlName) => {
                control.parent?.get(controlName)?.updateValueAndValidity();
            });
            return null;
        };
    }
}

class AbstractDetailsComponent {
    _loading;
    _ownerForm;
    _entity;
    constructor(formGroup) {
        this._loading = true;
        this._entity = null;
        this._ownerForm = formGroup;
    }
    get loading() {
        return this._loading;
    }
    set loading(value) {
        this._loading = value;
    }
    get entity() {
        return this._entity;
    }
    set entity(value) {
        this._entity = value;
    }
    get ownerForm() {
        return this._ownerForm;
    }
    get isLoaded() {
        return this._entity !== null;
    }
    hasError = (controlName, errorName) => {
        return this.ownerForm?.controls[controlName].hasError(errorName);
    };
    hasFormError = (errorName) => {
        return this.ownerForm?.hasError(errorName);
    };
    updateDateTime(controlName) {
        this.ownerForm?.get(controlName)?.setValue(IsoDateTime.utcToLocalDateTimeIso(IsoDateTime.currentUtcDateTimeIso()));
    }
    copyInputMessage(inputElement) {
        inputElement.select();
        document.execCommand('copy');
        inputElement.setSelectionRange(0, 0);
    }
    onProgressStarting() {
        this._loading = true;
        this.ownerForm?.disable();
        this.ownerForm?.updateValueAndValidity();
    }
    onProgressCompleted() {
        this.ownerForm?.enable();
        this._loading = false;
    }
}

/*
 * Public API Surface of shared-ui
 */

/**
 * Generated bundle index. Do not edit.
 */

export { AbstractDetailsComponent, ButtonTypes, CommonValidators, ConfirmationService, DialogType, FileUploadService, MmAutocompleteInputComponent, MmBreadcrumbComponent, MmConfirmationWindowComponent, MmEntitySelectInputComponent, MmFileUploadComponent, MmMultipleEntitySelectInputComponent, MmNotificationBarComponent, MmSharedUiModule, MmTableSimpleComponent, ProgressNotifierService };
//# sourceMappingURL=meshmakers-shared-ui.mjs.map
