import { DoCheck, ElementRef, EventEmitter, Injector, OnDestroy, OnInit } from "@angular/core";
import { MatFormFieldControl } from "@angular/material/form-field";
import { AbstractControl, ControlValueAccessor, FormControl, NgControl, ValidationErrors, Validator } from "@angular/forms";
import { MatAutocompleteActivatedEvent, MatAutocompleteSelectedEvent } from "@angular/material/autocomplete";
import { Subject } from "rxjs";
import { FocusMonitor } from "@angular/cdk/a11y";
import { AutoCompleteDataSource } from "@meshmakers/shared-services";
import * as i0 from "@angular/core";
export declare class MmAutocompleteInputComponent implements OnInit, OnDestroy, DoCheck, ControlValueAccessor, MatFormFieldControl<any>, Validator {
    elRef: ElementRef<HTMLElement>;
    private readonly injector;
    private readonly fm;
    private static nextId;
    readonly searchFormControl: FormControl;
    isLoading: boolean;
    filteredStrings: string[];
    ngControl: NgControl | null;
    errorState: boolean;
    focused: boolean;
    readonly stateChanges: Subject<void>;
    readonly id: string;
    valueChange: EventEmitter<any>;
    private _selectedString;
    private readonly inputField;
    private describedBy;
    private activatedValue;
    constructor(elRef: ElementRef<HTMLElement>, injector: Injector, fm: FocusMonitor);
    private _dataSource;
    get dataSource(): AutoCompleteDataSource | null;
    set dataSource(value: AutoCompleteDataSource | null);
    private _disabled;
    get disabled(): boolean;
    set disabled(dis: boolean);
    private _placeholder;
    get placeholder(): string;
    set placeholder(plh: string);
    private _required;
    get required(): boolean;
    set required(req: boolean);
    private _prefix;
    get prefix(): string;
    set prefix(value: string);
    get value(): any;
    set value(value: any);
    get empty(): boolean;
    get shouldLabelFloat(): boolean;
    ngOnInit(): void;
    ngOnDestroy(): void;
    ngDoCheck(): void;
    clear(): void;
    focus(): void;
    onOptionSelected(event: MatAutocompleteSelectedEvent): void;
    onOptionActivated(event: MatAutocompleteActivatedEvent): void;
    onAutoCompleteClosed(): void;
    reset(): void;
    onFocusOut(): void;
    onTouched(): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    writeValue(obj: any): void;
    setDisabledState(isDisabled: boolean): void;
    onContainerClick(event: MouseEvent): void;
    setDescribedByIds(ids: string[]): void;
    validate(control: AbstractControl): ValidationErrors | null;
    private _propagateChange;
    private readonly _onTouched;
    static ɵfac: i0.ɵɵFactoryDeclaration<MmAutocompleteInputComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<MmAutocompleteInputComponent, "mm-autocomplete", never, { "dataSource": { "alias": "dataSource"; "required": false; }; "disabled": { "alias": "disabled"; "required": false; }; "placeholder": { "alias": "placeholder"; "required": false; }; "required": { "alias": "required"; "required": false; }; "prefix": { "alias": "prefix"; "required": false; }; }, {}, never, never, false, never>;
}
